/*
 * generated by Xtext
 */
package org.openxma.dsl.core.formatting;

import org.eclipse.xtext.formatting.impl.AbstractDeclarativeFormatter;
import org.eclipse.xtext.formatting.impl.FormattingConfig;

/**
 * This class contains custom formatting description.
 *
 * see : http://www.eclipse.org/Xtext/documentation/latest/xtext.html#formatting
 * on how and when to use it
 *
 * Also see {@link org.eclipse.xtext.xtext.XtextFormattingTokenSerializer} as an example
 */
public class CoreDslFormatter extends AbstractDeclarativeFormatter {

    @Override
    public void configureFormatting(FormattingConfig c) {
        org.openxma.dsl.core.services.CoreDslGrammarAccess f = (org.openxma.dsl.core.services.CoreDslGrammarAccess) getGrammarAccess();

        // qualified names
        c.setNoSpace().around(f.getQualifiedNameAccess().getFullStopKeyword_1_0());

        // namespace
        c.setLinewrap(1).before(f.getModelAccess().getNamespaceKeyword_0_0());
        // import
        c.setLinewrap(1).before(f.getImportAccess().getImportKeyword_0_0());
        c.setLinewrap(1).before(f.getImportAccess().getImportKeyword_1_0());


        // types
        c.setLinewrap(1).before(f.getSimpleTypeAccess().getTypeKeyword_0_1());
        c.setNoSpace().around(f.getSimpleTypeAccess().getLeftParenthesisKeyword_0_3_0());
        c.setNoSpace().around(f.getSimpleTypeAccess().getCommaKeyword_0_3_2_0());
        c.setNoSpace().before(f.getSimpleTypeAccess().getRightParenthesisKeyword_0_3_3());

        // validators
        c.setLinewrap(1).before(f.getValidatorAccess().getValidatorKeyword_0());
        c.setNoSpace().around(f.getValidatorAccess().getLeftParenthesisKeyword_3_0());
        c.setNoSpace().around(f.getValidatorAccess().getCommaKeyword_3_2_0());
        c.setNoSpace().before(f.getValidatorAccess().getRightParenthesisKeyword_3_3());

        // validatorref
        c.setNoSpace().around(f.getValidatorReferenceAccess().getLeftParenthesisKeyword_1_0());
        c.setNoSpace().around(f.getValidatorReferenceAccess().getCommaKeyword_1_1_1_0());
        c.setNoSpace().before(f.getValidatorReferenceAccess().getRightParenthesisKeyword_1_2());

        // typeref
        c.setNoSpace().around(f.getDataTypeAndTypeParameterAccess().getLeftParenthesisKeyword_1_0());
        c.setNoSpace().around(f.getDataTypeAndTypeParameterAccess().getCommaKeyword_1_1_1_0());
        c.setNoSpace().before(f.getDataTypeAndTypeParameterAccess().getRightParenthesisKeyword_1_2());

        // enums
        c.setLinewrap(1).before(f.getEnumTypeAccess().getEnumKeyword_0());
        c.setLinewrap(1).before(f.getEnumTypeAccess().getRightCurlyBracketKeyword_3_0_2());
        c.setIndentation(f.getEnumTypeAccess().getLeftCurlyBracketKeyword_3_0_0(),f.getEnumTypeAccess().getRightCurlyBracketKeyword_3_0_2());
        c.setLinewrap(1).before(f.getEnumLiteralAccess().getNameIDTerminalRuleCall_0_0());
        c.setNoSpace().around(f.getEnumLiteralAccess().getLeftParenthesisKeyword_1_0());
        c.setNoSpace().around(f.getEnumLiteralAccess().getRightParenthesisKeyword_1_3());

    }
}
