/**
 * <copyright>
 * </copyright>
 *
 * $Id: ParameterDefinitionType.java 9011 2012-01-13 14:48:10Z mjohannes $
 */
package org.openxma.dsl.core.model;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Parameter Definition Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.openxma.dsl.core.CorePackage#getParameterDefinitionType()
 * @model
 * @generated
 */
public enum ParameterDefinitionType implements Enumerator {
	/**
     * The '<em><b>Integer</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #INTEGER_VALUE
     * @generated
     * @ordered
     */
	INTEGER(0, "integer", "integer"),

	/**
     * The '<em><b>String</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #STRING_VALUE
     * @generated
     * @ordered
     */
	STRING(1, "string", "string"),

	/**
     * The '<em><b>Boolean</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #BOOLEAN_VALUE
     * @generated
     * @ordered
     */
	BOOLEAN(2, "boolean", "boolean");

	/**
     * The '<em><b>Integer</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Integer</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #INTEGER
     * @model name="integer"
     * @generated
     * @ordered
     */
	public static final int INTEGER_VALUE = 0;

	/**
     * The '<em><b>String</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>String</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #STRING
     * @model name="string"
     * @generated
     * @ordered
     */
	public static final int STRING_VALUE = 1;

	/**
     * The '<em><b>Boolean</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Boolean</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #BOOLEAN
     * @model name="boolean"
     * @generated
     * @ordered
     */
	public static final int BOOLEAN_VALUE = 2;

	/**
     * An array of all the '<em><b>Parameter Definition Type</b></em>' enumerators.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private static final ParameterDefinitionType[] VALUES_ARRAY =
		new ParameterDefinitionType[] {
            INTEGER,
            STRING,
            BOOLEAN,
        };

	/**
     * A public read-only list of all the '<em><b>Parameter Definition Type</b></em>' enumerators.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static final List<ParameterDefinitionType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
     * Returns the '<em><b>Parameter Definition Type</b></em>' literal with the specified literal value.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static ParameterDefinitionType get(String literal) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            ParameterDefinitionType result = VALUES_ARRAY[i];
            if (result.toString().equals(literal)) {
                return result;
            }
        }
        return null;
    }

	/**
     * Returns the '<em><b>Parameter Definition Type</b></em>' literal with the specified name.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static ParameterDefinitionType getByName(String name) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            ParameterDefinitionType result = VALUES_ARRAY[i];
            if (result.getName().equals(name)) {
                return result;
            }
        }
        return null;
    }

	/**
     * Returns the '<em><b>Parameter Definition Type</b></em>' literal with the specified integer value.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static ParameterDefinitionType get(int value) {
        switch (value) {
            case INTEGER_VALUE: return INTEGER;
            case STRING_VALUE: return STRING;
            case BOOLEAN_VALUE: return BOOLEAN;
        }
        return null;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private final int value;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private final String name;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private final String literal;

	/**
     * Only this class can construct instances.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private ParameterDefinitionType(int value, String name, String literal) {
        this.value = value;
        this.name = name;
        this.literal = literal;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public int getValue() {
      return value;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String getName() {
      return name;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String getLiteral() {
      return literal;
    }

	/**
     * Returns the literal value of the enumerator, which is its string representation.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public String toString() {
        return literal;
    }
	
} //ParameterDefinitionType
